## Úvod
WinManager je nástroj, který přináší jednodušší správu aplikací a oken do Microsoft Windows. Umožňuje efektivnější přepínání a zavírání aplikací a oken optimalizované pro uživatele ovládající systém výhradně pomocí klávesnice nebo pomocí odečítače obrazovky. Práci usnadní zejména v případě, kdy máte spuštěno mnoho aplikací a jejich oken současně.

WinManager dále nabízí funkci snadno přístupného ale zároveň pokročilého a kvalitního obousměrného anglicko-českého slovníku, více informací viz níže v sekci "Funkce".

## Ukázky použití
Přínos nástroje WinManager lze demonstrovat nejlépe pomocí konkrétních ukázek jeho použití. Dejme tomu, že máte otevřené dva dokumenty aplikace Microsoft Word, dále pět oken webového prohlížeče Microsoft Edge, tři okna Průzkumníka souborů a ještě okno s doručenou poštou v aplikaci Microsoft Outlook.

### Ukázka 1: Přepínání nebo zavírání oken
řekněme, že se chcete přepnout do nebo zavřít určité okno aplikace Microsoft Edge, ve kterém jste něco hledali pomocí vyhledávače Google:

1. Stisknutím Windows + F12 nebo Windows + Shift + A vyvolejte nástroj WinManager. Zobrazí se seznam čtyř výše uvedených běžících aplikací.
2. Šipkou dolů se přesuňte na aplikaci "Microsoft Edge ", nebo jednoduše jenom napište "edge" pro vyfiltrování seznamu aplikací.
3. Stiskněte šipku doprava pro zobrazení všech oken aplikace Microsoft Edge.
4. Šipkou dolů se přesuňte na požadované okno s vyhledávačem Google, nebo vyfiltrujte seznam oken pouhým napsáním "Google".
5. Stiskněte Enter na požadovaném okně pro přepnutí do něj, nebo stiskněte Delete pro jeho zavření.

### Ukázka 2: Ukončování aplikací
Řekněme, že chcete zavřít aplikaci Microsoft Edge tak, aby se při jejím příštím spuštění zeptala na obnovení všech svých naposledy zavřených oken.

1. Stisknutím Windows + F12 nebo Windows + Shift + A vyvolejte nástroj WinManager. Zobrazí se seznam čtyř výše uvedených běžících aplikací.
2. Šipkou dolů se přesuňte na aplikaci "Microsoft Edge ", nebo jednoduše jenom napište "edge" pro vyfiltrování seznamu aplikací.
3. Stiskněte Shift + Delete pro vynucené ukončení Microsoft Edge, čímž zajistíte, že se při příštím spuštění zeptá na obnovení všech svých naposledy zavřených oken.

### Ukázka 3: Přepínání nebo ukončování oken pouze pro aplikaci v popředí
Řekněme, že máte otevřeného Průzkumníka a chcete se přepnout do nebo zavřít jeho jiné okno "Stahování", které jste používali před dlouhou dobou.

1. Stisknutím Windows + F11 nebo Windows + Shift + Q vyvolejte nástroj WinManager. Zobrazí se seznam otevřených oken jen pro aplikaci, která je právě v popředí, tedy pro Průzkumník.
2. Šipkou dolů se přesuňte na okno "Stahování"", nebo vyfiltrujte seznam oken pouhým napsáním "stah".
3. Stiskněte Enter na okně "Stahování" pro přepnutí do něj, nebo stiskněte Delete pro jeho zavření.

## Funkce
Po spuštění WinManager oznámí, že byl spuštěn, a poté běží na pozadí, dokud není vyvolána jeho funkcionalita pomocí odpovídajících klávesových zkratek, jež jsou globální, čili tyto zkratky fungují bez ohledu na to, jaká aplikace nebo okno je zrovna v popředí. Uživatel může vyvolat následující funkce:

* Seznam spuštěných aplikací a jejich otevřených oken.
* Seznam otevřených oken jen pro aplikaci, která je zrovna v popředí.
* Obousměrný anglicko-český slovník.

### Seznam spuštěných aplikací a jejich otevřených oken
Stisknutím zkratky Windows + F12 nebo alternativně Windows + Shift + A můžete kdykoliv vyvolat seznam právě spuštěných aplikací, který je seřazen dle naposledy použité aplikace. Se seznamem můžete pracovat pomocí následujících kláves:

* Šipka dolů nebo nahoru: Přesune vás na následující nebo předchozí položku v seznamu.
* Šipka doprava: Jestliže je vybrána aplikace, tak vás přesune do seznamu otevřených oken jen této vybrané aplikace.
* Šipka doleva: Jestliže je vybráno okno, tak vás přesune zpět do seznamu běžících aplikací.
* Enter: Jestliže je vybrána aplikace, přepne vás do naposledy používaného okna této aplikace. Pokud je vybráno okno, tak vás přepne do tohoto okna. Poté skryje WinManager.
* Delete: Jestliže je vybrána aplikace, ukončí tuto aplikaci. Pokud je vybráno okno, tak zavře toto okno. Chcete-li aplikaci ukončit vynuceně, stiskněte Shift + Delete. Upozornění: Vynucené ukončení aplikaci ukončí bez ohledu na to, jestli v ní máte neuloženou práci, kdežto běžné ukončení aplikace nebo zavírání okna může v případě, že v nich máte neuloženou práci, selhat.
* Escape: Skryje WinManager.
* Alt + F4: Ukončí WinManager, takže už nebude nadále běžet na pozadí. WinManager oznámí, že byl ukončen.

### Seznam otevřených oken jen pro aplikaci v popředí
Stisknutím zkratky Windows + F11 nebo alternativně Windows + Shift + Q můžete kdykoliv vyvolat seznam otevřených oken jen pro aplikaci, která je zrovna v popředí, jež je seřazen dle naposledy použitého okna. Se seznamem můžete pracovat pomocí následujících kláves:

* Šipka dolů nebo nahoru: Přesune vás na následující nebo předchozí okno v seznamu.
* Enter: Jestliže je vybráno okno, tak vás přepne do tohoto okna. Poté skryje WinManager.
* Delete: Jestliže je vybráno okno, tak zavře toto okno. Upozornění: Zavírání okna může v případě, že v něm máte neuloženou práci, selhat.
* Escape: Skryje WinManager.
* Alt + F4: Ukončí WinManager, takže už nebude nadále běžet na pozadí. WinManager oznámí, že byl ukončen.

### Obousměrný anglicko-český slovník
Stisknutím zkratky Windows + F10 nebo alternativně Windows + Shift + F můžete kdykoliv vyvolat pokročilý obousměrný anglicko-český slovník založený na kvalitním slovníku od Seznam.cz. Pro využití tohoto slovníku je však potřebné připojení k Internetu.

* Po vyvolání slovníku je do vyhledávacího pole pro zadání hledaného slovíčka automaticky předvyplněn text ze schránky a tento text je označen, takže ho následným psaním případně můžete snadno přepsat na jiné slovíčko.
* Stisknutím Enteru vyhledáte zadané slovíčko a fokus se sám přesune do oblasti s výsledkem hledání, kde se můžete pohybovat stejně jako na webové stránce.
* Klávesovou zkratkou Control + Shift + F se můžete kdykoliv přesunout zpět do pole pro zadání slovíčka.

### Nastavení nástroje WinManager
Nastavení je dostupné přes tlačítko „Nastavení a další“, na které se lze přesunout pomocí klávesy tabulátor nebo Shift + tabulátor v základním okně nástroje WinManager.

Po spuštění bude WinManager přidán mezi aplikace, které se spouští automaticky po přihlášení aktuálního uživatele do systému Microsoft Windows. Toto automatické spouštění nástroje WinManager můžete zrušit v dialogu pro jeho nastavení.

### Filtrování seznamu aplikací nebo oken psaním
Pro urychlení nalezení požadované aplikace nebo okna podporují seznam aplikací i oken funkcionalitu filtrování těchto seznamů prostřednictvím psaní, což znamená, že v případě, kdy je seznam zaměřen fokusem, můžete psát znaky a seznam bude okamžitě náležitě vyfiltrován, čili zobrazí se jen aplikace nebo okna, jejichž titulek obsahuje napsané znaky. Filtrování nerozlišuje velká a malá písmena.

Filtr je možné resetovat a opět tak zobrazit původní aplikace nebo okna stisknutím klávesy Backspace.

### Přenastavení globálních klávesových zkratek
Dialog s nastavením pro WinManager umožňuje konfiguraci globálních klávesových zkratek sloužících pro vyvolávání seznamu aplikací nebo oken či slovníku. V jednu chvíli je možné mít povoleno více klávesových zkratek najednou tak, aby pravděpodobnost konfliktu zkratek s jinými programy byla minimalizována.

K vyvolání seznamu spuštěných aplikací mohou sloužit následující zkratky:

* Windows + F12 (výchozí).
* Windows + Shift + A (výchozí).

K vyvolání seznamu otevřených oken jen pro aplikaci v popředí mohou sloužit následující zkratky:

* Windows + F11 (výchozí).
* Windows + Shift + Q (výchozí).

K vyvolání slovníku mohou sloužit následující zkratky:
* Windows + F10 (výchozí).
* Windows + Shift + F (výchozí).

## Známé problémy
* Někdy při pokusu o přepnutí se do okna se fokus do tohoto okna správně nepřesune. V takových situacích může pomoci stisknout Alt + tabulátor a poté Alt + Shift + tabulátor.

## Kontakt a zpětná vazba
Máte-li k nástroji WinManager nějaké nápady na zlepšení, potíže s jeho fungování nebo jiné připomínky, tak mi můžete napsat na email [adam.samec@gmail.com](mailto:adam.samec@gmail.com)

## Licence
WinManager je vyvíjen jako bezplatný program s otevřeným kódem pod licencí MIT, jejíž znění v angličtině je uvedeno níže.

### The MIT License (MIT)

Copyright (c) 2024 Adam Samec

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
